from web3 import AsyncWeb3


# https://github.com/Uniswap/uniswapx-sdk/blob/main/src/constants.ts
order_quoters = {  # ORDER_QUOTER_MAPPING
    1: AsyncWeb3.to_checksum_address("0x54539967a06Fc0E3C3ED0ee320Eb67362D13C5fF"),
    5: AsyncWeb3.to_checksum_address("0x54539967a06Fc0E3C3ED0ee320Eb67362D13C5fF"),
    137: AsyncWeb3.to_checksum_address("0x54539967a06Fc0E3C3ED0ee320Eb67362D13C5fF"),
    12341234: AsyncWeb3.to_checksum_address("0xbea0901A41177811b099F787D753436b2c47690E"),
}

order_quoter_abi = '[{"inputs":[],"name":"OrdersLengthIncorrect","type":"error"},{"inputs":[{"internalType":"bytes","name":"order","type":"bytes"}],"name":"getReactor","outputs":[{"internalType":"contract IReactor","name":"reactor","type":"address"}],"stateMutability":"pure","type":"function"},{"inputs":[{"internalType":"bytes","name":"order","type":"bytes"},{"internalType":"bytes","name":"sig","type":"bytes"}],"name":"quote","outputs":[{"components":[{"components":[{"internalType":"contract IReactor","name":"reactor","type":"address"},{"internalType":"address","name":"swapper","type":"address"},{"internalType":"uint256","name":"nonce","type":"uint256"},{"internalType":"uint256","name":"deadline","type":"uint256"},{"internalType":"contract IValidationCallback","name":"additionalValidationContract","type":"address"},{"internalType":"bytes","name":"additionalValidationData","type":"bytes"}],"internalType":"struct OrderInfo","name":"info","type":"tuple"},{"components":[{"internalType":"contract ERC20","name":"token","type":"address"},{"internalType":"uint256","name":"amount","type":"uint256"},{"internalType":"uint256","name":"maxAmount","type":"uint256"}],"internalType":"struct InputToken","name":"input","type":"tuple"},{"components":[{"internalType":"address","name":"token","type":"address"},{"internalType":"uint256","name":"amount","type":"uint256"},{"internalType":"address","name":"recipient","type":"address"}],"internalType":"struct OutputToken[]","name":"outputs","type":"tuple[]"},{"internalType":"bytes","name":"sig","type":"bytes"},{"internalType":"bytes32","name":"hash","type":"bytes32"}],"internalType":"struct ResolvedOrder","name":"result","type":"tuple"}],"stateMutability":"nonpayable","type":"function"},{"inputs":[{"components":[{"components":[{"internalType":"contract IReactor","name":"reactor","type":"address"},{"internalType":"address","name":"swapper","type":"address"},{"internalType":"uint256","name":"nonce","type":"uint256"},{"internalType":"uint256","name":"deadline","type":"uint256"},{"internalType":"contract IValidationCallback","name":"additionalValidationContract","type":"address"},{"internalType":"bytes","name":"additionalValidationData","type":"bytes"}],"internalType":"struct OrderInfo","name":"info","type":"tuple"},{"components":[{"internalType":"contract ERC20","name":"token","type":"address"},{"internalType":"uint256","name":"amount","type":"uint256"},{"internalType":"uint256","name":"maxAmount","type":"uint256"}],"internalType":"struct InputToken","name":"input","type":"tuple"},{"components":[{"internalType":"address","name":"token","type":"address"},{"internalType":"uint256","name":"amount","type":"uint256"},{"internalType":"address","name":"recipient","type":"address"}],"internalType":"struct OutputToken[]","name":"outputs","type":"tuple[]"},{"internalType":"bytes","name":"sig","type":"bytes"},{"internalType":"bytes32","name":"hash","type":"bytes32"}],"internalType":"struct ResolvedOrder[]","name":"resolvedOrders","type":"tuple[]"},{"internalType":"bytes","name":"","type":"bytes"}],"name":"reactorCallback","outputs":[],"stateMutability":"pure","type":"function"}]'  # noqa
